diff -uNrd ircd-ratbox-1.3-1/src/messages.tab BgChat-Ircd/src/messages.tab
--- ircd-ratbox-1.3-1/src/messages.tab	Thu Nov 20 14:44:39 2003
+++ BgChat-Ircd/src/messages.tab	Mon Apr  5 13:54:57 2004
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: messages.tab,v 7.90.2.8 2003/11/20 19:44:39 leeh Exp $
+ *   $Id: messages.tab,v 7.90.2.8 2004/03/01 22:10:12 HaKer4o Exp $
  */
 
 static  const char *  replies[] = {
@@ -24,7 +24,7 @@
 /* 001  RPL_WELCOME, */ ":%s 001 %s :Welcome to the %s Internet Relay Chat Network %s",
 /* 002  RPL_YOURHOST,*/ ":%s 002 %s :Your host is %s, running version %s",
 /* 003  RPL_CREATED, */ ":%s 003 %s :This server was created %s",
-/* 004  RPL_MYINFO, */ ":%s 004 %s %s %s oiwszcerkfydnxbauglZ biklmnopstveI bkloveI",
+/* 004  RPL_MYINFO, */ ":%s 004 %s %s %s oiwszcerkfydnxbauglZ biklmnopstlveILSYTZ bkloveSOACHM",
 /* 005  RPL_ISUPPORT, */ ":%s 005 %s %s :are supported by this server",
 /* 006 */       NULL,
 /* 007 */       NULL,
@@ -271,10 +271,8 @@
 
 /* 248 RPL_STATSULINE, */       ":%s 248 %s U %s %s@%s %s",
 /* 249 RPL_STATSDEBUG */       NULL,
-/* 250 RPL_STATSCONN, */
-                ":%s 250 %s :Highest connection count: %d (%d clients) (%d connections received)",
-/* 251 RPL_LUSERCLIENT, */
-                ":%s 251 %s :There are %d users and %d invisible on %d servers",
+/* 250 RPL_STATSCONN, */        ":%s 250 %s :Highest connection count: %d (%d clients) (%d connections received)",
+/* 251 RPL_LUSERCLIENT, */      ":%s 251 %s :There are %d users and %d invisible on %d servers",
 /* 252 RPL_LUSEROP, */          ":%s 252 %s %d :IRC Operators online",
 /* 253 RPL_LUSERUNKNOWN, */     ":%s 253 %s %d :unknown connection(s)",
 /* 254 RPL_LUSERCHANNELS, */    ":%s 254 %s %d :channels formed",
@@ -286,14 +284,13 @@
 /* 260 */       NULL,
 /* 261 RPL_TRACELOG, */         ":%s 261 %s File %s %d",
 /* 262 RPL_ENDOFTRACE, */       ":%s 262 %s %s :End of TRACE",
-/* 263 RPL_LOAD2HI, */          
-":%s 263 %s %s :Server load is temporarily too heavy. Please wait a while and try again.",
+/* 263 RPL_LOAD2HI, */          ":%s 263 %s %s :Server load is temporarily too heavy. Please wait a while and try again.",
 /* 264 */       NULL,
 /* 265 RPL_LOCALUSERS, */       ":%s 265 %s :Current local  users: %d  Max: %d",
 /* 266 RPL_GLOBALUSERS, */      ":%s 266 %s :Current global users: %d  Max: %d",
-/* 267 */       NULL,
-/* 268 */       NULL,
-/* 269 */       NULL,
+/* 267 RPL_IDENTUSERS, */       ":%s 267 %s :Current identified users: %d  Max: %d",
+/* 268 RPL_OSIDUSERS, */        ":%s 268 %s :Current services Admins: %d  Max: %d",
+/* 269 RPL_GLIDUSERS, */        ":%s 269 %s :Current gliner Admins: %d  Max: %d",
 /* 270 */       NULL,
 /* 271 */       NULL,
 /* 272 */       NULL,
@@ -306,7 +303,7 @@
 /* 279 */       NULL,
 /* 280 */       NULL,
 /* 281 RPL_ACCEPTLIST, */       ":%s 281 %s %s :",
-/* 282 RPL_ENDOFACCEPT */       ":%s 282 %s :End of /ACCEPT list.",
+/* 282 RPL_ENDOFACCEPT, */       ":%s 282 %s :End of /ACCEPT list.",
 /* 283 */       NULL,
 /* 284 */       NULL,
 /* 285 */       NULL,
@@ -318,7 +315,7 @@
 /* 291 */       NULL,
 /* 292 */       NULL,
 /* 293 */       NULL,
-/* 294 */       NULL,
+/* 294 RPL_INGMODE, */       ":%s 294 %s %s :is in +g mode (caller id)",
 /* 295 */       NULL,
 /* 296 */       NULL,
 /* 297 */       NULL,
@@ -332,7 +329,7 @@
 /* 305 RPL_UNAWAY, */   ":%s 305 %s :You are no longer marked as being away",
 /* 306 RPL_NOWAWAY, */  ":%s 306 %s :You have been marked as being away",
 /* 307 */       NULL,
-/* 308 */	NULL,
+/* 308 */       NULL,
 /* 309 */       NULL,
 /* 310 */       NULL,
 /* 311 RPL_WHOISUSER, */        ":%s 311 %s %s %s %s * :%s",
@@ -344,16 +341,16 @@
 /* 317 RPL_WHOISIDLE, */        ":%s 317 %s %s %d %d :seconds idle, signon time",
 /* 318 RPL_ENDOFWHOIS, */       ":%s 318 %s %s :End of /WHOIS list.",
 /* 319 RPL_WHOISCHANNELS, */    ":%s 319 %s %s :",
-/* 320 */      NULL,
+/* 320 */       NULL,
 /* 321 RPL_LISTSTART, */        ":%s 321 %s Channel :Users  Name",
 /* 322 RPL_LIST, */             ":%s 322 %s %s %d :%s",
 /* 323 RPL_LISTEND, */          ":%s 323 %s :End of /LIST",
 /* 324 RPL_CHANNELMODEIS, */    ":%s 324 %s %s %s %s",
-/* 325 */       NULL,
-/* 326 */       NULL,
-/* 327 */       NULL,
-/* 328 */       NULL,
-/* 329 RPL_CREATIONTIME, */      ":%s 329 %s %s %lu", 
+/* 325 RPL_WHOISSVSHINT, */     ":%s 325 %s %s :has identified to NS",
+/* 326 RPL_OS_ID, */            ":%s 326 %s %s :is a Services Administrator",
+/* 327 RPL_NK_ID, */            ":%s 327 %s %s :is a Gliner Administrator",
+/* 328 RPL_SILENCE */           ":%s 328 %s %s :Accepts messages from registered nicks only",
+/* 329 RPL_CREATIONTIME, */     ":%s 329 %s %s %lu", 
 /* 330 */       NULL,
 /* 331 RPL_NOTOPIC, */          ":%s 331 %s %s :No topic is set.",
 /* 332 RPL_TOPIC, */            ":%s 332 %s %s :%s",
@@ -439,7 +436,7 @@
 /* 412 ERR_NOTEXTTOSEND, */     ":%s 412 %s :No text to send",
 /* 413 ERR_NOTOPLEVEL, */       ":%s 413 %s %s :No toplevel domain specified",
 /* 414 ERR_WILDTOPLEVEL, */     ":%s 414 %s %s :Wildcard in toplevel Domain",
-/* 415 */       NULL,
+/* 415 ERR_SERV_NICK, */        ":%s 415 %s %s :- You Can not Kick/Deop Services nick!",
 /* 416 ERR_TOOMANYMATCHES */    ":%s 416 %s %s :output too large, truncated",
 /* 417 */       NULL,
 /* 418 */       NULL,
@@ -477,7 +474,7 @@
 /* 449 */       NULL,
 /* 450 */       NULL,
 /* 451 ERR_NOTREGISTERED, */    ":%s 451 %s :You have not registered",
-/* 452 */       NULL,
+/* 452 ERR_NOREPEATING, */      ":%s 452 %s %s :No repeating allowed (+z)",
 /* 453 */       NULL,
 /* 454 */       NULL,
 /* 455 */       NULL,
@@ -494,10 +491,10 @@
 /* 466 ERR_YOUWILLBEBANNED, */  NULL,
 /* 467 ERR_KEYSET, */           ":%s 467 %s %s :Channel key already set",
 /* 468 */       NULL,
-/* 469 */       NULL,
-/* 470 */       NULL,
+/* 469 */			":%s 469 %s %s :Cannot join channel (+A). IRC Server Admins only!!!",
+/* 470 */       		":%s 470 %s %s :Cannot join channel (+O). IRC Operators only!!!",
 /* 471 ERR_CHANNELISFULL, */    ":%s 471 %s %s :Cannot join channel (+l)",
-/* 472 ERR_UNKNOWNMODE  , */    ":%s 472 %s %c :is unknown mode char to me",
+/* 472 ERR_UNKNOWNMODE  , */    ":%s 472 %s %c :is unknown mode char to me!",
 /* 473 ERR_INVITEONLYCHAN, */   ":%s 473 %s %s :Cannot join channel (+i)",
 /* 474 ERR_BANNEDFROMCHAN, */   ":%s 474 %s %s :Cannot join channel (+b)",
 /* 475 ERR_BADCHANNELKEY, */    ":%s 475 %s %s :Cannot join channel (+k)",
@@ -516,12 +513,12 @@
 /* 486 */       NULL,
 /* 487 */       NULL,
 /* 488 */       NULL,
-/* 489 */       NULL,
-/* 490 */       NULL,
+/* 489 ERR_NOCOLOR, */ ":%s 489 %s %s :Colors are forbidden on this channel!",
+/* 490 ERR_JOINF, */   ":%s 490 %s %s :Can't join the channel, because your nick is either not regged or too young!",
 /* 491 ERR_NOOPERHOST, */       ":%s 491 %s :Only few of mere mortals may try to enter the twilight zone",
-/* 492 */       NULL,
-/* 493 */       NULL,
-/* 494 */       NULL,
+/* 492 ERR_NOCTCP, */           ":%s 492 %s %s :CTCP messages from non +v/+o/+h are forbidden!",
+/* 493 ERR_NOTALK, */           ":%s 493 %s %s :You can't talk on this channel, while your nickname is not regged ot regged too recently!",
+/* 494 ERR_NOSPAM, */           ":%s 494 %s %s :You can't send this to the channel, while it contains a spam phrase, if you think it's not contact the admin (/ADMIN)",
 /* 495 */       NULL,
 /* 496 */       NULL,
 /* 497 */       NULL,
diff -uNrd ircd-ratbox-1.3-1/src/modules.c BgChat-Ircd/src/modules.c
--- ircd-ratbox-1.3-1/src/modules.c	Thu Jun 26 10:03:16 2003
+++ BgChat-Ircd/src/modules.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  modules.c: A module loader.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: modules.c,v 7.127.2.1 2003/06/26 14:03:16 androsyn Exp $
+ *  $Id: modules.c,v 7.127.2.1 2004/02/09 14:03:16 HaKer4o Exp $
  */
 
 #include "stdinc.h"
@@ -590,6 +589,7 @@
 	mod_add_cmd(&squit_msgtab);
 	mod_add_cmd(&stats_msgtab);
 	mod_add_cmd(&svinfo_msgtab);
+	mod_add_cmd(&svshint_msgtab);
 	mod_add_cmd(&testline_msgtab);
 	mod_add_cmd(&time_msgtab);
 	mod_add_cmd(&topic_msgtab);
diff -uNrd ircd-ratbox-1.3-1/src/motd.c BgChat-Ircd/src/motd.c
--- ircd-ratbox-1.3-1/src/motd.c	Sun Oct 12 08:50:45 2003
+++ BgChat-Ircd/src/motd.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  motd.c: Message of the day functions.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: motd.c,v 7.34.4.2 2003/10/12 12:50:45 leeh Exp $
+ *  $Id: motd.c,v 7.34.4.2 2004/02/09 12:50:45 HaKer4o Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.3-1/src/newconf.c BgChat-Ircd/src/newconf.c
--- ircd-ratbox-1.3-1/src/newconf.c	Fri Dec 19 12:33:03 2003
+++ BgChat-Ircd/src/newconf.c	Mon Mar 29 07:17:51 2004
@@ -1,5 +1,5 @@
 /* This code is in the public domain.
- * $Id: newconf.c,v 7.93.2.18 2003/12/19 17:33:03 androsyn Exp $
+ * $Id: newconf.c,v 7.93.2.18 2002/12/19 17:33:03 HaKer4o Exp $
  */
 
 #include "stdinc.h"
@@ -3068,6 +3068,9 @@
 
 	add_top_conf("exempt", conf_begin_exempt, conf_end_exempt);
 	add_conf_item("exempt", "ip", CF_QSTRING, conf_set_exempt_ip);
+
+	add_top_conf("spamcheck", NULL, NULL);
+	add_conf_item("spamcheck", "adv_text", CF_QSTRING, add_adv_text);
 
 	add_top_conf("gecos", conf_begin_gecos, conf_end_gecos);
 	add_conf_item("gecos", "name", CF_QSTRING, conf_set_gecos_name);
diff -uNrd ircd-ratbox-1.3-1/src/numeric.c BgChat-Ircd/src/numeric.c
--- ircd-ratbox-1.3-1/src/numeric.c	Thu Jun 26 10:03:17 2003
+++ BgChat-Ircd/src/numeric.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  numeric.c: Numeric handling functions.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: numeric.c,v 7.26.2.1 2003/06/26 14:03:17 androsyn Exp $
+ *  $Id: numeric.c,v 7.26.2.1 2004/02/09 14:03:17 HaKer4o Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.3-1/src/packet.c BgChat-Ircd/src/packet.c
--- ircd-ratbox-1.3-1/src/packet.c	Thu Jun 26 10:03:17 2003
+++ BgChat-Ircd/src/packet.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  packet.c: Packet handlers.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: packet.c,v 7.118.2.1 2003/06/26 14:03:17 androsyn Exp $
+ *  $Id: packet.c,v 7.118.2.1 2004/02/09 14:03:17 HaKer4o Exp $
  */
 #include "stdinc.h"
 #include "tools.h"
diff -uNrd ircd-ratbox-1.3-1/src/parse.c BgChat-Ircd/src/parse.c
--- ircd-ratbox-1.3-1/src/parse.c	Mon Sep 22 11:17:35 2003
+++ BgChat-Ircd/src/parse.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  parse.c: The message parser.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: parse.c,v 7.160.2.4 2003/09/22 15:17:35 androsyn Exp $
+ *  $Id: parse.c,v 7.160.2.4 2004/02/09 15:17:35 HaKer4o Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.3-1/src/reject.c BgChat-Ircd/src/reject.c
--- ircd-ratbox-1.3-1/src/reject.c	Fri Nov 14 11:17:11 2003
+++ BgChat-Ircd/src/reject.c	Mon Mar 29 07:17:51 2004
@@ -1,9 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd
+ *  ircd-hybrid: A slightly useful ircd
  *  reject.c: reject users with prejudice
  *
- *  Copyright 2003 Aaron Sethman <androsyn@ratbox.org>
- *  Copyright 2003 ircd-ratbox development team
+ *  Copyright 2003 Aaron Sethman <androsyn@ircd-hybrid.org>
+ *  Copyright 2003 ircd-hybrid development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -20,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: reject.c,v 1.4.2.9 2003/11/14 16:17:11 leeh Exp $
+ *  $Id: reject.c,v 1.4.2.9 2004/02/09 16:17:11 HaKer4o Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.3-1/src/restart.c BgChat-Ircd/src/restart.c
--- ircd-ratbox-1.3-1/src/restart.c	Thu Jun 26 10:03:17 2003
+++ BgChat-Ircd/src/restart.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  restart.c: Functions to allow the ircd to restart.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: restart.c,v 7.28.2.1 2003/06/26 14:03:17 androsyn Exp $
+ *  $Id: restart.c,v 7.28.2.1 2004/02/09 14:03:17 HaKer4o Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.3-1/src/resv.c BgChat-Ircd/src/resv.c
--- ircd-ratbox-1.3-1/src/resv.c	Mon Sep 22 17:17:32 2003
+++ BgChat-Ircd/src/resv.c	Mon Mar 29 07:17:51 2004
@@ -1,9 +1,8 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  resv.c: Functions to reserve(jupe) a nick/channel.
  *
  *  Copyright (C) 2001-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -20,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: resv.c,v 7.30.2.3 2003/09/22 21:17:32 androsyn Exp $
+ *  $Id: resv.c,v 7.30.2.3 2004/02/09 21:17:32 HaKer4o Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.3-1/src/rsa.c BgChat-Ircd/src/rsa.c
--- ircd-ratbox-1.3-1/src/rsa.c	Thu Jun 26 10:03:17 2003
+++ BgChat-Ircd/src/rsa.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  rsa.c: Functions for use with RSA public key cryptography.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: rsa.c,v 7.32.2.1 2003/06/26 14:03:17 androsyn Exp $
+ *  $Id: rsa.c,v 7.32.2.1 2004/02/09 14:03:17 HaKer4o Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.3-1/src/s_auth.c BgChat-Ircd/src/s_auth.c
--- ircd-ratbox-1.3-1/src/s_auth.c	Tue Sep  2 18:58:01 2003
+++ BgChat-Ircd/src/s_auth.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  s_auth.c: Functions for querying a users ident.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
diff -uNrd ircd-ratbox-1.3-1/src/s_bsd.c BgChat-Ircd/src/s_bsd.c
--- ircd-ratbox-1.3-1/src/s_bsd.c	Wed Oct 15 12:34:04 2003
+++ BgChat-Ircd/src/s_bsd.c	Mon Mar 29 07:17:51 2004
@@ -1,5 +1,5 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  s_bsd.c: Network functions.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
diff -uNrd ircd-ratbox-1.3-1/src/s_bsd_devpoll.c BgChat-Ircd/src/s_bsd_devpoll.c
--- ircd-ratbox-1.3-1/src/s_bsd_devpoll.c	Wed Oct 15 12:34:04 2003
+++ BgChat-Ircd/src/s_bsd_devpoll.c	Mon Mar 29 07:17:51 2004
@@ -1,11 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  s_bsd_devpoll.c: /dev/poll compatible network routines.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2001 Adrian Chadd <adrian@creative.net.au>
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -22,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_bsd_devpoll.c,v 7.25.2.2 2003/10/15 16:34:04 androsyn Exp $
+ *  $Id: s_bsd_devpoll.c,v 7.25.2.2 2004/02/08 16:34:04 HaKer4o Exp $
  */
 
 #include "config.h"
diff -uNrd ircd-ratbox-1.3-1/src/s_bsd_epoll.c BgChat-Ircd/src/s_bsd_epoll.c
--- ircd-ratbox-1.3-1/src/s_bsd_epoll.c	Wed Oct 15 14:07:08 2003
+++ BgChat-Ircd/src/s_bsd_epoll.c	Mon Mar 29 07:17:51 2004
@@ -1,12 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  epoll.c: Linux epoll compatible network routines.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2001 Adrian Chadd <adrian@creative.net.au>
- *  Copyright (C) 2002 ircd-ratbox development team
- *  Copyright (C) 2002 Aaron Sethman <androsyn@ratbox.org>
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
diff -uNrd ircd-ratbox-1.3-1/src/s_bsd_kqueue.c BgChat-Ircd/src/s_bsd_kqueue.c
--- ircd-ratbox-1.3-1/src/s_bsd_kqueue.c	Mon Dec  1 14:14:51 2003
+++ BgChat-Ircd/src/s_bsd_kqueue.c	Mon Mar 29 07:17:51 2004
@@ -1,11 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  kqueue.c: FreeBSD kqueue compatible network routines.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2001 Adrian Chadd <adrian@creative.net.au>
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
diff -uNrd ircd-ratbox-1.3-1/src/s_bsd_poll.c BgChat-Ircd/src/s_bsd_poll.c
--- ircd-ratbox-1.3-1/src/s_bsd_poll.c	Wed Oct 15 12:34:05 2003
+++ BgChat-Ircd/src/s_bsd_poll.c	Mon Mar 29 07:17:51 2004
@@ -1,11 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  s_bsd_poll.c: POSIX poll() compatible network routines.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2001 Adrian Chadd <adrian@creative.net.au>
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
diff -uNrd ircd-ratbox-1.3-1/src/s_bsd_select.c BgChat-Ircd/src/s_bsd_select.c
--- ircd-ratbox-1.3-1/src/s_bsd_select.c	Wed Oct 15 12:34:05 2003
+++ BgChat-Ircd/src/s_bsd_select.c	Mon Mar 29 07:17:51 2004
@@ -1,11 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  s_bsd_select.c: select() compatible network routines.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2001 Adrian Chadd <adrian@creative.net.au>
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
diff -uNrd ircd-ratbox-1.3-1/src/s_conf.c BgChat-Ircd/src/s_conf.c
--- ircd-ratbox-1.3-1/src/s_conf.c	Fri Dec 19 12:33:03 2003
+++ BgChat-Ircd/src/s_conf.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  s_conf.c: Configuration file functions.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002-2003 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_conf.c,v 7.416.2.20 2003/12/19 17:33:03 androsyn Exp $
+ *  $Id: s_conf.c,v 7.416.2.20 2003/12/19 17:33:03 HaKer4o Exp $
  */
 
 #include "stdinc.h"
@@ -117,6 +116,16 @@
 /* conf uline link list root */
 struct ConfItem *u_conf = ((struct ConfItem *) NULL);
 
+struct DCCForb {
+  char *fileext;
+  struct DCCForb *next;
+};
+
+// static struct DCCForb *dccforb = NULL;
+
+static struct DCCForb *quitcheck = NULL;
+
+
 /*
  * conf_dns_callback
  * inputs	- pointer to struct ConfItem
@@ -1279,9 +1288,10 @@
 	DupString(ConfigFileEntry.servlink_path, SLPATH);
 	ConfigFileEntry.egdpool_path = NULL;
 	ConfigFileEntry.use_whois_actually = YES;
-	strlcpy(ConfigFileEntry.default_operstring, "is an IRC Operator",sizeof(ConfigFileEntry.default_operstring));
-	strlcpy(ConfigFileEntry.default_adminstring, "is a Server Administrator", sizeof(ConfigFileEntry.default_adminstring));
+        strlcpy(ConfigFileEntry.default_operstring, "is an IRC Operator",sizeof(ConfigFileEntry.default_operstring));
+        strlcpy(ConfigFileEntry.default_adminstring, "is a Server Administrator",sizeof(ConfigFileEntry.default_adminstring));
 
+	
 	ConfigFileEntry.reject_after_count = 5;
 	ConfigFileEntry.reject_ban_time = 300;
 	ConfigFileEntry.reject_duration = 120;
@@ -2573,5 +2583,28 @@
 conf_yy_fatal_error(const char *msg)
 {
 	return (0);
+}
+
+void add_adv_text(void *data)
+{
+  struct DCCForb *fileextf;
+  char * param = data;
+  if (!param[0]) return;
+
+  fileextf = (struct DCCForb*) MyMalloc(sizeof(struct DCCForb));
+  DupString(fileextf->fileext, param);
+  fileextf->next = quitcheck;
+  quitcheck = fileextf;
+}
+
+int IsAdvQuit(char *file)
+{
+  struct DCCForb *fileextf;
+
+  for (fileextf = quitcheck; fileextf; fileextf = fileextf->next)
+    if (match(fileextf->fileext, file))
+	  return 1;
+
+  return 0;
 }
 
diff -uNrd ircd-ratbox-1.3-1/src/s_debug.c BgChat-Ircd/src/s_debug.c
--- ircd-ratbox-1.3-1/src/s_debug.c	Thu Aug 14 19:26:11 2003
+++ BgChat-Ircd/src/s_debug.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  s_debug.c: Some assorted debug functions.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_debug.c,v 7.94.2.3 2003/08/14 23:26:11 leeh Exp $
+ *  $Id: s_debug.c,v 7.94.2.3 2004/02/07 23:26:11 HaKer4o Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.3-1/src/s_gline.c BgChat-Ircd/src/s_gline.c
--- ircd-ratbox-1.3-1/src/s_gline.c	Sat Jun 28 07:39:49 2003
+++ BgChat-Ircd/src/s_gline.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  s_gline.c: GLine global ban functions.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_gline.c,v 1.37.4.2 2003/06/28 11:39:49 leeh Exp $
+ *  $Id: s_gline.c,v 1.37.4.2 2004/02/05 11:39:49 HaKer4o Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.3-1/src/s_log.c BgChat-Ircd/src/s_log.c
--- ircd-ratbox-1.3-1/src/s_log.c	Thu Jun 26 10:03:19 2003
+++ BgChat-Ircd/src/s_log.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  s_log.c: Logger functions.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_log.c,v 7.54.2.1 2003/06/26 14:03:19 androsyn Exp $
+ *  $Id: s_log.c,v 7.54.2.1 2004/02/01 14:03:19 MaskBg Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.3-1/src/s_misc.c BgChat-Ircd/src/s_misc.c
--- ircd-ratbox-1.3-1/src/s_misc.c	Sat Jun 28 07:39:49 2003
+++ BgChat-Ircd/src/s_misc.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  s_misc.c: Yet another miscellaneous functions file.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_misc.c,v 7.32.2.1 2003/06/28 11:39:49 leeh Exp $
+ *  $Id: s_misc.c,v 7.32.2.1 2004/02/03 11:39:49 HaKer4o Exp $
  */
 
 #include "stdinc.h"
@@ -52,6 +51,109 @@
 	"Sunday", "Monday", "Tuesday", "Wednesday",
 	"Thursday", "Friday", "Saturday"
 };
+
+/* next few lines are the services'  */
+
+char* servnicks[] = {
+		 "NS",
+		 "MS",
+         "CS",
+         "OS",
+		 "HS",
+         "STATSERV",
+         "STARTX",
+         "SEENSERV",
+         "ADMINSERV",
+         "SPLITSERV",
+		 "GLINER",
+		 "SOCKCLEAN",
+		 "MONITOR",
+		 "INFO",
+                 "seen",
+                   "STX",
+		 "IFCONFIG",
+		 "INFO",
+		 "SERVICES",
+		 "CHANSERVICES",
+		 "GLINERSERVICES"
+};
+#define ARR_SIZE 17 /* services line */
+
+/* s_check ()
+ * will verify that the nick to be kicked is not a service nick
+ * and stop if it is
+ *                       
+ */
+
+long s_check( char * szName )
+{
+    int i = 0;
+    for( i=0;i<ARR_SIZE;i++)
+        if( !strcasecmp(szName, servnicks[i]))
+            return 1;
+    return 0;
+}
+
+/* end of s_check() */
+
+/* no color  */
+char *strip_color(const char *p, int b)
+{
+  static char buf[512];
+  char *r, *q = buf;
+  int m, n;
+
+  do switch (*p) {
+
+  case '\003':
+    p++; if (isdigit(*p)) {
+      p++; m = *p>='0' && *p<='6';
+      n = *(p-1)=='1' || *(p-1)=='0';
+      if (m && n) {
+        p++; if (*p == ',') {
+          p++; if (isdigit(*p)) {
+            p++; m = *p>='0' && *p<='6';
+            n = *(p-1)=='1' || *(p-1)=='0';
+            if (m && n) {
+              p++;
+            }
+          }
+        }
+      } else if (*p == ',') {
+        p++; if (isdigit(*p)) {
+          p++; m = *p>='0' && *p<='6';
+          n = *(p-1)=='1' || *(p-1)=='0';
+          if (m && n) {
+            p++;
+          }
+        }
+      }
+    }
+    break;
+
+  case '\033':
+    p++; if (*p == '[') {
+      p++; r = strchr(p, 'm');
+      if (r) p = r + 1;
+    }
+    break;
+
+  case '\002':
+  case '\037':
+    if (b) {
+      p++; break;
+    }
+
+  default:
+    *q++ = *p++;
+    break;
+
+  } while (*p);
+
+  *q = 0;
+  return buf;
+}
+
 
 char *
 date(time_t lclock)
